using System;
using System.Collections.Generic;
using System.Text;
using SOAPClasses.VZA ; 

namespace SOAPClasses
{
    public class Binder
    {
        ///<summary>
        /// Method to bind types
        /// </summary>
        public System.Object InitBinding(System.Type bindingType, bool target)
        {
            string typeName = bindingType.Name;
            System.Object Binding =
                bindingType.GetConstructor(System.Type.EmptyTypes).Invoke(null);
            bindingType.GetProperty("Url").SetValue(Binding, URL, null);
            packet_headerType header = new packet_headerType();
            header.session = session;
            if (target)
            {
                header.target = new string[1];
                header.target[0] = typeName.Replace("Binding", "");
            }
            bindingType.GetField("packet_header").SetValue(Binding, header);
            ((System.Web.Services.Protocols.SoapHttpClientProtocol)Binding).Timeout = -1;
            return Binding;
        }

        public System.Object InitBinding(System.Type bindingType)
        {
            string typeName = bindingType.Name;
            System.Object Binding =
              bindingType.GetConstructor(System.Type.EmptyTypes).Invoke(null);
            bindingType.GetProperty("Url").SetValue(Binding, URL, null);
            packet_headerType header = new packet_headerType();
            header.session = session;
            header.target = new string[1];
            header.target[0] = typeName.Replace("Binding", "");
            bindingType.GetField("packet_header").SetValue(Binding, header);
            ((System.Web.Services.Protocols.SoapHttpClientProtocol)Binding).Timeout = -1;
            return Binding;
        }

        public System.Object InitBinding(System.Type bindingType,string targetName)
        {
            string typeName = bindingType.Name;
            System.Object Binding =
              bindingType.GetConstructor(System.Type.EmptyTypes).Invoke(null);
            bindingType.GetProperty("Url").SetValue(Binding, URL, null);
            packet_headerType header = new packet_headerType();
            header.session = session;
            header.target = new string[1];
            header.target[0] = targetName;
            bindingType.GetField("packet_header").SetValue(Binding, header);
            ((System.Web.Services.Protocols.SoapHttpClientProtocol)Binding).Timeout = -1;
            return Binding;
        }

        public Binder(string url, string sess)
        {
            URL = url;
            session = sess;
        }

        public string URL;
        public string session;
    }
}
