using System;
using System.Collections.Generic;
using System.Text;

namespace SOAPClasses
{

    class TracePointsChecker
    {
        private Dictionary<string, int> tracelist;
        public TracePointsChecker()
        {
            tracelist = new Dictionary<string, int>();
        }

        public void add(string v)
        {
            tracelist.Add(v, 0);
        }

        public void trace(string point)
        {
            if (tracelist.ContainsKey(point))
                tracelist[point]++;
        }

        public string report()
        {
            string err = "";
            foreach (KeyValuePair<string, int> v in tracelist)
            {
                if (v.Value == 0)
                    err = err + " " + v.Key;
            }
            return err;
        }


    }

    public class eidList : List<string>
    {
    }

   public class Generic
    {
       public Generic()
       {
 
       }

       public string WaitTime(int period)
       {
           try
           {
               System.Threading.Thread.Sleep(period);
               return "OK!";
           }
           catch (Exception e)
           {
               return e.Message;
           }
       }

       public string isEmpty(string obj)
       {
           if (obj != "")
               return "OK!";
           else
               throw new Exception("Test Exception: string is empty!");
       }
    }
}
